	IDT	'TIME'
	TITL	'TIME - System time routines'
***********************************************************************
*
*   TIME - System time routines.
*
***********************************************************************
	OPTION	DUNLST,BUNLST,TUNLST
*
	COPY	'config.cpy'
*
	LDEF	_time,__stime
*
	LREF	___addsi3,___subsi3,___mulsi3
	LREF	__year2day
	ASMIF	STKCHK=1
	LREF	__stkoverflow,__stktop
	ASMEND
*
* Convert system block to time in seconds since 1970.
*
* time_t _stime (int t1[5], time_t *t);
*
__stime
	STWP	R10
	AI	R10,32
	MOV	R10,R11
	AI	R11,10
	ASMIF	STKCHK=1
	C	@__stktop,R11
	JH	time005
	BL	@__stkoverflow
	TEXT	'_stime'
	BYTE	0
	EVEN
	ASMEND
time005
	MOV	@2(R13),R9
	MOV	*R9+,R7
	MOV	R10,R4
	MOV	*R7+,*R4+
	MOV	*R7+,*R4+
	MOV	*R7+,*R4+
	MOV	*R7+,*R4+
	MOV	*R7,*R4
	JMP	time020
*
* Get time in seconds since 1970.
*
* time_t time (time_t *t);
*
_time
	STWP	R10
	AI	R10,32
	MOV	R10,R11
	AI	R11,10
	ASMIF	STKCHK=1
	C	@__stktop,R11
	JH	time010
	BL	@__stkoverflow
	TEXT	'time'
	BYTE	0
	EVEN
	ASMEND
time010
	MOV	@2(R13),R9
	MOV	R10,R4
	MOV	=W2007,*R4+	Fake time for StandAlone mode
	MOV	=W344,*R4+
	MOV	=W1,*R4+
	MOV	=W52,*R4+
	MOV	=W4,*R4
	MOV	R11,R2
	MOV	=X0300,*R11+	Get time from the system
	MOV	R10,*R11+
	MOV	R11,R1
	MOV	R2,*R11+
	MOV	=@__issue_svc,R12
	BLWP	R11
	AI	R11,-6
time020
	CLR	R7
	MOV	@2(R10),R8	Get Days
	CLR	R0		temp = year2day (year);
	MOV	*R10,R1
	DEC	R1
	LI	R12,__year2day
	BLWP	R11
	MOV	R0,R2
	MOV	R1,R3
	MOV	R11,R1		temp += days
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	R7,*R11+
	MOV	R8,*R11+
	MOV	=@___addsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	R0,R2		temp
	MOV	R1,R3
	MOV	R11,R1		temp -= epoc;
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	@EPOC,*R11+
	MOV	@EPOC+2,*R11+
	MOV	=@___subsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	R0,R2		temp
	MOV	R1,R3
	MOV	R11,R1		temp *= 24;
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	@D24,*R11+
	MOV	@D24+2,*R11+
	MOV	=@___mulsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	R0,R2		temp
	MOV	R1,R3
	CLR	R7
	MOV	@4(R10),R8	temp += hours;
	MOV	R11,R1
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	R7,*R11+
	MOV	R8,*R11+
	MOV	=@___addsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	R0,R2		temp
	MOV	R1,R3
	MOV	R11,R1		temp *= 60;
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	@D60,*R11+
	MOV	@D60+2,*R11+
	MOV	=@___mulsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	R0,R2		temp
	MOV	R1,R3
	CLR	R7
	MOV	@6(R10),R8	temp += minutes;
	MOV	R11,R1
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	R7,*R11+
	MOV	R8,*R11+
	MOV	=@___addsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	R0,R2		temp
	MOV	R1,R3
	MOV	R11,R1		temp *= 60;
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	@D60,*R11+
	MOV	@D60+2,*R11+
	MOV	=@___mulsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	R0,R2		temp
	MOV	R1,R3
	CLR	R7
	MOV	@8(R10),R8	temp += seconds;
	MOV	R11,R1
	MOV	R2,*R11+
	MOV	R3,*R11+
	MOV	R7,*R11+
	MOV	R8,*R11+
	MOV	=@___addsi3,R12
	BLWP	R11
	AI	R11,-8
	MOV	*R9,R9		if (t)
	JEQ	time050
	MOV	R0,*R9+		   *t = temp;
	MOV	R1,*R9
time050
	MOV	R0,*R13		return temp;
	MOV	R1,@2(R13)
	RTWP
*
D24	LONG	24
D60	LONG	60
EPOC	LONG	719163		1970
	END
